$(() => {
let maxID = employees[employees.length - 1].ID;
const isChief = function (position) {
return position && ['CEO', 'CMO'].indexOf(position.trim().toUpperCase()) >= 0;
};
$('#grid-container').dxDataGrid({
dataSource: employees,
showBorders: true,
keyExpr: 'ID',
paging: {
enabled: false,
},
editing: {
mode: 'row',
allowUpdating: true,
allowDeleting(e) {
return !isChief(e.row.data.Position);
},
useIcons: true,
},
onRowValidating(e) {
const position = e.newData.Position;
if (isChief(position)) {
e.errorText = `The company can have only one ${position.toUpperCase()}. Please choose another position.`;
e.isValid = false;
}
},
onEditorPreparing(e) {
if (e.parentType === 'dataRow' && e.dataField === 'Position') {
e.editorOptions.readOnly = isChief(e.value);
}
},
columns: [
{
type: 'buttons',
width: 110,
buttons: ['edit', 'delete', {
hint: 'Clone',
icon: 'copy',
visible(e) {
return !e.row.isEditing;
},
disabled(e) {
return isChief(e.row.data.Position);
},
onClick(e) {
const clonedItem = $.extend({}, e.row.data, { ID: maxID += 1 });
employees.splice(e.row.rowIndex, 0, clonedItem);
e.component.refresh(true);
e.event.preventDefault();
},
}],
},
{
dataField: 'Prefix',
caption: 'Title',
},
'FirstName',
'LastName',
{
dataField: 'Position',
width: 130,
}, {
dataField: 'StateID',
caption: 'State',
width: 125,
lookup: {
dataSource: states,
displayExpr: 'Name',
valueExpr: 'ID',
},
}, {
dataField: 'BirthDate',
dataType: 'date',
width: 125,
},
],
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="grid-container"></div>
</div>
</body>
</html>
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 3,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
const states = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];

import React from 'react';
import DataGrid, {
Button, Column, Editing, Lookup,
} from 'devextreme-react/data-grid';
import service from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.state = { employees: service.getEmployees() };
this.states = service.getStates();
this.allowDeleting = this.allowDeleting.bind(this);
this.onRowValidating = this.onRowValidating.bind(this);
this.onEditorPreparing = this.onEditorPreparing.bind(this);
this.isCloneIconVisible = this.isCloneIconVisible.bind(this);
this.isCloneIconDisabled = this.isCloneIconDisabled.bind(this);
this.cloneIconClick = this.cloneIconClick.bind(this);
}
isChief(position) {
return position && ['CEO', 'CMO'].indexOf(position.trim().toUpperCase()) >= 0;
}
allowDeleting(e) {
return !this.isChief(e.row.data.Position);
}
onRowValidating(e) {
const position = e.newData.Position;
if (this.isChief(position)) {
e.errorText = `The company can have only one ${position.toUpperCase()}. Please choose another position.`;
e.isValid = false;
}
}
onEditorPreparing(e) {
if (e.parentType === 'dataRow' && e.dataField === 'Position') {
e.editorOptions.readOnly = this.isChief(e.value);
}
}
isCloneIconVisible(e) {
return !e.row.isEditing;
}
isCloneIconDisabled(e) {
return this.isChief(e.row.data.Position);
}
cloneIconClick(e) {
const employees = [...this.state.employees];
const clonedItem = { ...e.row.data, ID: service.getMaxID() };
employees.splice(e.row.rowIndex, 0, clonedItem);
this.setState({ employees });
e.event.preventDefault();
}
render() {
return (
<DataGrid
id="gridContainer"
dataSource={this.state.employees}
keyExpr="ID"
showBorders={true}
onRowValidating={this.onRowValidating}
onEditorPreparing={this.onEditorPreparing}>
<Editing
mode="row"
useIcons={true}
allowUpdating={true}
allowDeleting={this.allowDeleting} />
<Column type="buttons" width={110}>
<Button name="edit" />
<Button name="delete" />
<Button hint="Clone" icon="copy" visible={this.isCloneIconVisible} disabled={this.isCloneIconDisabled} onClick={this.cloneIconClick} />
</Column>
<Column dataField="Prefix" caption="Title" />
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column dataField="Position" width={130} />
<Column dataField="StateID" caption="State" width={125}>
<Lookup dataSource={this.states} displayExpr="Name" valueExpr="ID" />
</Column>
<Column dataField="BirthDate" dataType="date" width={125} />
</DataGrid>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 3,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
const states = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
let maxID = employees[employees.length - 1].ID;
export default {
getMaxID() {
maxID += 1;
return maxID;
},
getEmployees() {
return employees;
},
getStates() {
return states;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.5/cjs',
'devextreme-react': 'npm:devextreme-react@23.1.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.1/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.48/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<DxDataGrid
id="gridContainer"
:data-source="employees"
:show-borders="true"
key-expr="ID"
@row-validating="rowValidating"
@editor-preparing="editorPreparing"
>
<DxPaging :enabled="false"/>
<DxEditing
:allow-updating="true"
:allow-deleting="allowDeleting"
:use-icons="true"
mode="row"
/>
<DxColumn
type="buttons"
:width="110"
>
<DxButton name="edit"/>
<DxButton name="delete"/>
<DxButton
hint="Clone"
icon="repeat"
:visible="isCloneIconVisible"
@click="cloneIconClick"
/>
</DxColumn>
<DxColumn
data-field="Prefix"
caption="Title"
/>
<DxColumn data-field="FirstName"/>
<DxColumn data-field="LastName"/>
<DxColumn
:width="130"
data-field="Position"
/>
<DxColumn
:width="125"
data-field="StateID"
caption="State"
>
<DxLookup
:data-source="states"
display-expr="Name"
value-expr="ID"
/>
</DxColumn>
<DxColumn
:width="125"
data-field="BirthDate"
data-type="date"
/>
</DxDataGrid>
</div>
</template>
<script>
import {
DxDataGrid,
DxColumn,
DxEditing,
DxButton,
DxPaging,
DxLookup
} from 'devextreme-vue/data-grid';
import service from './data.js';
export default {
components: {
DxDataGrid,
DxColumn,
DxEditing,
DxButton,
DxPaging,
DxLookup
},
data() {
return {
employees: service.getEmployees(),
states: service.getStates()
};
},
methods: {
isChief(position) {
return position && ['CEO', 'CMO'].indexOf(position.trim().toUpperCase()) >= 0;
},
isCloneIconVisible(e) {
return !e.row.isEditing && !this.isChief(e.row.data.Position);
},
cloneIconClick(e) {
const employees = [...this.employees];
const clonedItem = { ...e.row.data, ID: service.getMaxID() };
employees.splice(e.row.rowIndex, 0, clonedItem);
this.employees = employees;
e.event.preventDefault();
},
rowValidating(e) {
const position = e.newData.Position;
if(this.isChief(position)) {
e.errorText = `The company can have only one ${ position.toUpperCase() }. Please choose another position.`;
e.isValid = false;
}
},
editorPreparing(e) {
if(e.parentType === 'dataRow' && e.dataField === 'Position') {
e.editorOptions.readOnly = this.isChief(e.value);
}
},
allowDeleting(e) {
return !this.isChief(e.row.data.Position);
}
}
};
</script>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
const employees = [{
'ID': 1,
'FirstName': 'John',
'LastName': 'Heart',
'Prefix': 'Mr.',
'Position': 'CEO',
'BirthDate': '1964/03/16',
'HireDate': '1995/01/15',
'Notes': 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
'Address': '351 S Hill St.',
'StateID': 5
}, {
'ID': 2,
'FirstName': 'Robert',
'LastName': 'Reagan',
'Prefix': 'Mr.',
'Position': 'CMO',
'BirthDate': '1974/09/07',
'HireDate': '2002/11/08',
'Notes': 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
'Address': '4 Westmoreland Pl.',
'StateID': 4
}, {
'ID': 3,
'FirstName': 'Olivia',
'LastName': 'Peyton',
'Prefix': 'Mrs.',
'Position': 'Sales Assistant',
'BirthDate': '1981/06/03',
'HireDate': '2012/05/14',
'Notes': 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
'Address': '807 W Paseo Del Mar',
'StateID': 5
}, {
'ID': 4,
'FirstName': 'Greta',
'LastName': 'Sims',
'Prefix': 'Ms.',
'Position': 'HR Manager',
'BirthDate': '1977/11/22',
'HireDate': '1998/04/23',
'Notes': "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
'Address': '1700 S Grandview Dr.',
'StateID': 11
}, {
'ID': 5,
'FirstName': 'Brett',
'LastName': 'Wade',
'Prefix': 'Mr.',
'Position': 'IT Manager',
'BirthDate': '1968/12/01',
'HireDate': '2009/03/06',
'Notes': 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
'Address': '1120 Old Mill Rd.',
'StateID': 13
}, {
'ID': 6,
'FirstName': 'Sandra',
'LastName': 'Johnson',
'Prefix': 'Mrs.',
'Position': 'Controller',
'BirthDate': '1974/11/15',
'HireDate': '2005/05/11',
'Notes': "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
'Address': '4600 N Virginia Rd.',
'StateID': 44
}, {
'ID': 7,
'FirstName': 'Kevin',
'LastName': 'Carter',
'Prefix': 'Mr.',
'Position': 'Shipping Manager',
'BirthDate': '1978/01/09',
'HireDate': '2009/08/11',
'Notes': 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
'Address': '424 N Main St.',
'StateID': 5
}, {
'ID': 8,
'FirstName': 'Cynthia',
'LastName': 'Stanwick',
'Prefix': 'Ms.',
'Position': 'HR Assistant',
'BirthDate': '1985/06/05',
'HireDate': '2008/03/24',
'Notes': 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
'Address': '2211 Bonita Dr.',
'StateID': 4
}, {
'ID': 9,
'FirstName': 'Kent',
'LastName': 'Samuelson',
'Prefix': 'Dr.',
'Position': 'Ombudsman',
'BirthDate': '1972/09/11',
'HireDate': '2009/04/22',
'Notes': 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
'Address': '12100 Mora Dr',
'StateID': 26
}, {
'ID': 10,
'FirstName': 'Taylor',
'LastName': 'Riley',
'Prefix': 'Mr.',
'Position': 'Network Admin',
'BirthDate': '1982/08/14',
'HireDate': '2012/04/14',
'Notes': "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
'Address': '7776 Torreyson Dr',
'StateID': 5
}, {
'ID': 11,
'FirstName': 'Sam',
'LastName': 'Hill',
'Prefix': 'Mr.',
'Position': 'Sales Assistant',
'BirthDate': '1984/02/17',
'HireDate': '2012/02/01',
'Notes': 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
'Address': '645 Prospect Crescent',
'StateID': 11
}, {
'ID': 12,
'FirstName': 'Kelly',
'LastName': 'Rodriguez',
'Prefix': 'Ms.',
'Position': 'Support Assistant',
'BirthDate': '1988/05/11',
'HireDate': '2012/10/13',
'Notes': "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
'Address': '1601 W Mountain St.',
'StateID': 5
}, {
'ID': 13,
'FirstName': 'Natalie',
'LastName': 'Maguirre',
'Prefix': 'Mrs.',
'Position': 'Trainer',
'BirthDate': '1977/10/07',
'HireDate': '2008/06/19',
'Notes': 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
'Address': '6400 E Bixby Hill Rd',
'StateID': 29
}, {
'ID': 14,
'FirstName': 'Walter',
'LastName': 'Hobbs',
'Prefix': 'Mr.',
'Position': 'Programmer',
'BirthDate': '1984/12/24',
'HireDate': '2011/02/17',
'Notes': "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
'Address': '10385 Shadow Oak Dr',
'StateID': 13
}];
const states = [{
'ID': 1,
'Name': 'Alabama'
}, {
'ID': 2,
'Name': 'Alaska'
}, {
'ID': 3,
'Name': 'Arizona'
}, {
'ID': 4,
'Name': 'Arkansas'
}, {
'ID': 5,
'Name': 'California'
}, {
'ID': 6,
'Name': 'Colorado'
}, {
'ID': 7,
'Name': 'Connecticut'
}, {
'ID': 8,
'Name': 'Delaware'
}, {
'ID': 9,
'Name': 'District of Columbia'
}, {
'ID': 10,
'Name': 'Florida'
}, {
'ID': 11,
'Name': 'Georgia'
}, {
'ID': 12,
'Name': 'Hawaii'
}, {
'ID': 13,
'Name': 'Idaho'
}, {
'ID': 14,
'Name': 'Illinois'
}, {
'ID': 15,
'Name': 'Indiana'
}, {
'ID': 16,
'Name': 'Iowa'
}, {
'ID': 17,
'Name': 'Kansas'
}, {
'ID': 18,
'Name': 'Kentucky'
}, {
'ID': 19,
'Name': 'Louisiana'
}, {
'ID': 20,
'Name': 'Maine'
}, {
'ID': 21,
'Name': 'Maryland'
}, {
'ID': 22,
'Name': 'Massachusetts'
}, {
'ID': 23,
'Name': 'Michigan'
}, {
'ID': 24,
'Name': 'Minnesota'
}, {
'ID': 25,
'Name': 'Mississippi'
}, {
'ID': 26,
'Name': 'Missouri'
}, {
'ID': 27,
'Name': 'Montana'
}, {
'ID': 28,
'Name': 'Nebraska'
}, {
'ID': 29,
'Name': 'Nevada'
}, {
'ID': 30,
'Name': 'New Hampshire'
}, {
'ID': 31,
'Name': 'New Jersey'
}, {
'ID': 32,
'Name': 'New Mexico'
}, {
'ID': 33,
'Name': 'New York'
}, {
'ID': 34,
'Name': 'North Carolina'
}, {
'ID': 35,
'Name': 'Ohio'
}, {
'ID': 36,
'Name': 'Oklahoma'
}, {
'ID': 37,
'Name': 'Oregon'
}, {
'ID': 38,
'Name': 'Pennsylvania'
}, {
'ID': 39,
'Name': 'Rhode Island'
}, {
'ID': 40,
'Name': 'South Carolina'
}, {
'ID': 41,
'Name': 'South Dakota'
}, {
'ID': 42,
'Name': 'Tennessee'
}, {
'ID': 43,
'Name': 'Texas'
}, {
'ID': 44,
'Name': 'Utah'
}, {
'ID': 45,
'Name': 'Vermont'
}, {
'ID': 46,
'Name': 'Virginia'
}, {
'ID': 47,
'Name': 'Washington'
}, {
'ID': 48,
'Name': 'West Virginia'
}, {
'ID': 49,
'Name': 'Wisconsin'
}, {
'ID': 50,
'Name': 'Wyoming'
}, {
'ID': 51,
'Name': 'North Dakota'
}];
let maxID = employees[employees.length - 1].ID;
export default {
getMaxID() {
return ++maxID;
},
getEmployees() {
return employees;
},
getStates() {
return states;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-vue': 'npm:devextreme-vue@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Command Column Customization

The DataGrid supports multiple predefined types of command columns. Each column type supports one type of action (edit, select, drag, etc.). This demo shows how to customize the Edit Command Column. This column type contains predefined edit buttons and optional custom buttons.

Predefined buttons
The available selection of predefined buttons depends on the selected edit mode, and the availability of the update and delete operations. To enable them, set the allowUpdating and allowDeleting properties to true. You can also set any of these properties to a custom function that enables the corresponding operation and displays its button only for certain rows.

This demo has the following configuration:

  • Edit mode is set to "row".

  • allowUpdating is enabled to display Edit buttons in all rows.

  • allowDeleting is set to a function that hides the Delete button based on a custom condition.

The predefined edit buttons are displayed as textual links by default. To use icons instead, set the useIcons property to true.

Custom buttons
If a command column should contain custom buttons, add its configuration to the columns array. DataGrid will display this column according to its position in this array. Specify the column's type as "buttons" and declare the buttons array. It should contain your custom buttons along with the predefined buttons. If you need to customize a predefined button, add an object with specified name and other button properties. If customization is not required, add only button names.

In this demo, the edit column contains one custom button (Clone) and two predefined buttons (Edit and Delete) without customization.

Backend API
<dx-data-grid id="gridContainer" [dataSource]="employees" [showBorders]="true" keyExpr="ID" (onRowValidating)="onRowValidating($event)" (onEditorPreparing)="onEditorPreparing($event)" > <dxo-paging [enabled]="false"></dxo-paging> <dxo-editing mode="row" [allowUpdating]="true" [allowDeleting]="isDeleteIconVisible" [useIcons]="true" ></dxo-editing> <dxi-column type="buttons" [width]="110"> <dxi-button name="edit"></dxi-button> <dxi-button name="delete"></dxi-button> <dxi-button hint="Clone" icon="copy" [visible]="isCloneIconVisible" [disabled]="isCloneIconDisabled" [onClick]="onCloneIconClick" ></dxi-button> </dxi-column> <dxi-column dataField="Prefix" caption="Title"></dxi-column> <dxi-column dataField="FirstName"></dxi-column> <dxi-column dataField="LastName"></dxi-column> <dxi-column dataField="Position" [width]="130"></dxi-column> <dxi-column dataField="StateID" [width]="125" caption="State"> <dxo-lookup [dataSource]="states" displayExpr="Name" valueExpr="ID" ></dxo-lookup> </dxi-column> <dxi-column dataField="BirthDate" [width]="125" dataType="date"></dxi-column> </dx-data-grid>
import { NgModule, Component, enableProdMode } from '@angular/core'; import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { DxDataGridModule, DxDataGridTypes } from 'devextreme-angular/ui/data-grid'; import { Service, Employee, State } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } type FirstArgument<T> = T extends (...args: any) => any ? Parameters<T>[0]: never; @Component({ selector: 'demo-app', templateUrl: 'app/app.component.html', styleUrls: ['app/app.component.css'], providers: [Service], }) export class AppComponent { employees: Employee[]; states: State[]; constructor(private service: Service) { this.employees = service.getEmployees(); this.states = service.getStates(); } private static isChief(position: string) { return position && ['CEO', 'CMO'].indexOf(position.trim().toUpperCase()) >= 0; } isCloneIconVisible({ row }: FirstArgument<DxDataGridTypes.ColumnButton['visible']>) { return !row.isEditing; } isCloneIconDisabled({ row }: FirstArgument<DxDataGridTypes.ColumnButton['disabled']>) { return AppComponent.isChief((row.data).Position); } isDeleteIconVisible({ row }: FirstArgument<DxDataGridTypes.Editing['allowDeleting']>) { return !AppComponent.isChief((row.data as Record<string, string>).Position); } onRowValidating(e: DxDataGridTypes.RowValidatingEvent) { const position = e.newData.Position as string; if (AppComponent.isChief(position)) { e.errorText = `The company can have only one ${position.toUpperCase()}. Please choose another position.`; e.isValid = false; } } onEditorPreparing(e: DxDataGridTypes.EditorPreparingEvent) { if (e.parentType === 'dataRow' && e.dataField === 'Position') { e.editorOptions.readOnly = AppComponent.isChief(e.value); } } onCloneIconClick = (e: DxDataGridTypes.ColumnButtonClickEvent) => { const clonedItem = { ...e.row.data, ID: this.service.getMaxID() }; this.employees.splice(e.row.rowIndex, 0, clonedItem); e.event.preventDefault(); }; } @NgModule({ imports: [ BrowserModule, BrowserTransferStateModule, DxDataGridModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
import { Injectable } from '@angular/core'; export class Employee { ID: number; FirstName: string; LastName: string; Prefix: string; Position: string; BirthDate: string; HireDate: string; Notes: string; Address: string; StateID: number; } export class State { ID: number; Name: string; } const employees: Employee[] = [{ ID: 1, FirstName: 'John', LastName: 'Heart', Prefix: 'Mr.', Position: 'CEO', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St.', StateID: 5, }, { ID: 2, FirstName: 'Robert', LastName: 'Reagan', Prefix: 'Mr.', Position: 'CMO', BirthDate: '1974/09/07', HireDate: '2002/11/08', Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.', Address: '4 Westmoreland Pl.', StateID: 4, }, { ID: 3, FirstName: 'Olivia', LastName: 'Peyton', Prefix: 'Mrs.', Position: 'Sales Assistant', BirthDate: '1981/06/03', HireDate: '2012/05/14', Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.', Address: '807 W Paseo Del Mar', StateID: 5, }, { ID: 4, FirstName: 'Greta', LastName: 'Sims', Prefix: 'Ms.', Position: 'HR Manager', BirthDate: '1977/11/22', HireDate: '1998/04/23', Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.", Address: '1700 S Grandview Dr.', StateID: 11, }, { ID: 5, FirstName: 'Brett', LastName: 'Wade', Prefix: 'Mr.', Position: 'IT Manager', BirthDate: '1968/12/01', HireDate: '2009/03/06', Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).', Address: '1120 Old Mill Rd.', StateID: 13, }, { ID: 6, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.", Address: '4600 N Virginia Rd.', StateID: 44, }, { ID: 7, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', StateID: 5, }, { ID: 8, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', StateID: 4, }, { ID: 9, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', StateID: 26, }, { ID: 10, FirstName: 'Taylor', LastName: 'Riley', Prefix: 'Mr.', Position: 'Network Admin', BirthDate: '1982/08/14', HireDate: '2012/04/14', Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.", Address: '7776 Torreyson Dr', StateID: 5, }, { ID: 11, FirstName: 'Sam', LastName: 'Hill', Prefix: 'Mr.', Position: 'Sales Assistant', BirthDate: '1984/02/17', HireDate: '2012/02/01', Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.', Address: '645 Prospect Crescent', StateID: 11, }, { ID: 12, FirstName: 'Kelly', LastName: 'Rodriguez', Prefix: 'Ms.', Position: 'Support Assistant', BirthDate: '1988/05/11', HireDate: '2012/10/13', Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.", Address: '1601 W Mountain St.', StateID: 5, }, { ID: 13, FirstName: 'Natalie', LastName: 'Maguirre', Prefix: 'Mrs.', Position: 'Trainer', BirthDate: '1977/10/07', HireDate: '2008/06/19', Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.', Address: '6400 E Bixby Hill Rd', StateID: 29, }, { ID: 14, FirstName: 'Walter', LastName: 'Hobbs', Prefix: 'Mr.', Position: 'Programmer', BirthDate: '1984/12/24', HireDate: '2011/02/17', Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.", Address: '10385 Shadow Oak Dr', StateID: 13, }]; const states: State[] = [{ ID: 1, Name: 'Alabama', }, { ID: 2, Name: 'Alaska', }, { ID: 3, Name: 'Arizona', }, { ID: 4, Name: 'Arkansas', }, { ID: 5, Name: 'California', }, { ID: 6, Name: 'Colorado', }, { ID: 7, Name: 'Connecticut', }, { ID: 8, Name: 'Delaware', }, { ID: 9, Name: 'District of Columbia', }, { ID: 10, Name: 'Florida', }, { ID: 11, Name: 'Georgia', }, { ID: 12, Name: 'Hawaii', }, { ID: 13, Name: 'Idaho', }, { ID: 14, Name: 'Illinois', }, { ID: 15, Name: 'Indiana', }, { ID: 16, Name: 'Iowa', }, { ID: 17, Name: 'Kansas', }, { ID: 18, Name: 'Kentucky', }, { ID: 19, Name: 'Louisiana', }, { ID: 20, Name: 'Maine', }, { ID: 21, Name: 'Maryland', }, { ID: 22, Name: 'Massachusetts', }, { ID: 23, Name: 'Michigan', }, { ID: 24, Name: 'Minnesota', }, { ID: 25, Name: 'Mississippi', }, { ID: 26, Name: 'Missouri', }, { ID: 27, Name: 'Montana', }, { ID: 28, Name: 'Nebraska', }, { ID: 29, Name: 'Nevada', }, { ID: 30, Name: 'New Hampshire', }, { ID: 31, Name: 'New Jersey', }, { ID: 32, Name: 'New Mexico', }, { ID: 33, Name: 'New York', }, { ID: 34, Name: 'North Carolina', }, { ID: 35, Name: 'Ohio', }, { ID: 36, Name: 'Oklahoma', }, { ID: 37, Name: 'Oregon', }, { ID: 38, Name: 'Pennsylvania', }, { ID: 39, Name: 'Rhode Island', }, { ID: 40, Name: 'South Carolina', }, { ID: 41, Name: 'South Dakota', }, { ID: 42, Name: 'Tennessee', }, { ID: 43, Name: 'Texas', }, { ID: 44, Name: 'Utah', }, { ID: 45, Name: 'Vermont', }, { ID: 46, Name: 'Virginia', }, { ID: 47, Name: 'Washington', }, { ID: 48, Name: 'West Virginia', }, { ID: 49, Name: 'Wisconsin', }, { ID: 50, Name: 'Wyoming', }, { ID: 51, Name: 'North Dakota', }]; @Injectable() export class Service { maxID = employees[employees.length - 1].ID; getMaxID() { return ++this.maxID; } getEmployees(): Employee[] { return employees; } getStates(): State[] { return states; } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', '@angular/core': 'npm:@angular/core@12.2.17', '@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17', '@angular/forms': 'npm:@angular/forms@12.2.17', '@angular/common': 'npm:@angular/common@12.2.17', '@angular/compiler': 'npm:@angular/compiler@12.2.17', 'tslib': 'npm:tslib@2.6.2/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme/bundles/dx.all': 'npm:devextreme@23.2.5/bundles/dx.all.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51', 'devextreme-angular': 'npm:devextreme-angular@23.2.5', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', 'npm:@angular/*/package.json', 'npm:@angular/common@12.2.17/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devextreme-angular@23.2.5/*/package.json', 'npm:devextreme-angular@23.2.5/ui/*/package.json', 'npm:devextreme-angular@23.2.5/package.json', 'npm:devexpress-diagram@2.2.5/package.json', 'npm:devexpress-gantt@4.1.51/package.json', ], }; System.config(window.config);
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script> <script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>